# !Correct My CR2s.py (Prototype 0.02)
# Script for correcting figure/bodypart names of my BookStack4 figures when nested as a stack

import poser,random

# I put my scripts into a class simply to avoid possible conflict with stuff in the __main__ module.
class cheapskatesTemporaryClass(object):
	
	# List of all the BookStack4 figures linked underneath the selected one
	figlist = []
	
	# Recursive function to get any BookStack4 figures to which this, or any of its parent, BookStack4 figures are parented
	def getAnyParentStackFigures(self,thisfig):
		print ("\ngetAnyParentStackFigures()")
		act = thisfig.ParentActor()
		print ("thisfig.ParentActor() = " + act.Name())
		parentact = act.Parent()
		parentactname = parentact.Name()
		print ("and its parent actor is " + parentact.Name())
		if parentactname[:10] == "TopOfStack":
			return 1
		return 0
	
	# Recursive function to get any BookStack4 figures that are parented to TopOfStack of the main, or of any nested, BookStack4 figure
	def getAnyChildStackFigure(self, thisfig):
		print ("getAnyChildStackFigure()")
		
		act = thisfig.ActorByInternalName("top_of_stack")
		actlist = act.Children()
		for a in actlist:
			if a.ItsFigure():
				childfig = a.ItsFigure()
				figname = childfig.Name()
				if figname[:9] == "BookStack":
					print ("Adding '" + figname +"' to figlist[]")
					self.figlist.append(figname)
					self.getAnyChildStackFigure(childfig)
					
		return
	
	def main(self):
		
		# Get Poser version for doing version-specific stuff
		poserversion = '0'
		posermainversion = '0'
		try:
			self.poserversion = poser.AppVersion()
			temp = self.poserversion.split('.')
			self.posermainversion = temp[0]
		except:
			pass
			
		# Abort if the user gets cold feet right at the start
		confirmed = poser.DialogSimple.YesNo("FOR CORRECTING MY BOOKSTACK CR2 FILES\n\nDo you wish to continue?")
		if not confirmed:
			return
			
		# Abort if the selected figure's not a BookStack4
		fig = poser.Scene().CurrentFigure()
		if not (fig.Name()[:9] == "BookStack"):
			poser.DialogSimple.MessageBox("This script is only for use with the 3DCheapskate's 'BookStack' figures.\n\nScript aborted, no changes made.")
			return
		
		print ("Adding '" + fig.Name() +"' to figlist[]")
		self.figlist.append(fig.Name())
		
		if self.getAnyParentStackFigures(fig):
			print ("SELECTED FIGURE IS NOT BOTTOM OF STACK - ABORTED!")
		else:
			print ("Selected figure is bottom of stack so ok to proceed")
		
			self.getAnyChildStackFigure(fig)
				
			bkcnt = 1
			for f in self.figlist:
			
				# Get the figure
				fig = poser.Scene().Figure(f)
				print ("Figure name: " + fig.Name() + " ...should be " + str(bkcnt) + "-" + str(bkcnt+3))
				newfigname = "BookStack4 - books " + str(bkcnt) + "-" + str(bkcnt+3)
				if fig.Name() != newfigname:
					fig.SetName(newfigname)
					print ("*** Name changed to: " + fig.Name())
				
				# 'stack' bone
				bone = "stack"
				act = fig.ActorByInternalName(bone)
				print (" Bodypart: " + act.Name() + " ...should be 'Stack" + str(bkcnt) + "-" + str(bkcnt+3))
				newactname = "Stack" + str(bkcnt) + "-" + str(bkcnt+3)
				if act.Name() != newactname:
					act.SetName(newactname)
					print (" >>> Name changed to: " + act.Name())
				
				# 'stack' bone
				bone = "top_of_stack"
				act = fig.ActorByInternalName(bone)
				print (" Bodypart: " + act.Name() + " ...should be 'TopOfStack" + str(bkcnt) + "-" + str(bkcnt+3))
				newactname = "TopOfStack" + str(bkcnt) + "-" + str(bkcnt+3)
				if act.Name() != newactname:
					act.SetName(newactname)
					print (" >>> Name changed to: " + act.Name())
				
				# For each of the four books in the figure
				i = 1
				while i < 5:
					
					# Get the relevant bone/bodypart
					bone = "book_" + str(i)
					act = fig.ActorByInternalName(bone)
					print (" Bodypart: " + act.Name() + " ...should be " + str(bkcnt +i-1))
					newactname = "Book " + str(bkcnt +i-1)
					if act.Name() != newactname:
						act.SetName(newactname)
						print (" >>> Name changed to: " + act.Name())
					
					# Reset dimensions
					p = act.Parameter("Cover proportions")
					
					# Increment book number for next iteration
					i = i + 1
					
				bkcnt=bkcnt+4
			
			# Redraw what we've modified	
			poser.Scene().Draw()
			
poser.DialogSimple.MessageBox("Running 3DCheapskates !Correct My CR2s.py.py script\n\n(N.B. You should see a similar message when the script finishes. If you don't then the script has crashed!)")
cheapskatesTemporaryInstance = cheapskatesTemporaryClass()
cheapskatesTemporaryInstance.main()
poser.DialogSimple.MessageBox("3DCheapskates !Correct My CR2s.py script all done.")